---------------
----------------------------------------------------------------------
-- Derby Lua Script
-- By Bidwars
-------------------------------------------------------------------------------------

local M = {}

math.randomseed(os.time())  --This is used for Random Math.
local scenario = nil --Scenario Saved to this
--Helper for scenario lua commands
require('mathlib')
local maxspeed = 4
local vdata = {}
local tdata = {}
local data = {}
local Arena = 0
M.mapPath = {}
local pathData = {}
local helper = require('scenario/scenariohelper')

local function seek()
	--local targetPos = vdata.pos + (vdata.pos - tpos) * 100

	local dirVec = vdata.dirVec
	--local dirVec = vdata.vel:normalized()
	local desired = (data.target - vdata.pos):normalized()
	
	--if dirTarget is negitive then the target is behind
	local dirTarget = dirVec:dot(desired)
	local dirDiff = math.asin(dirVec.x * desired.y - dirVec.y * desired.x)
	--local aimToTarget = (target - vdata.pos):normalized()
	--local maxspeed = vdata.vel:length()
	--aimToTarget = aimToTarget * maxspeed 
	--local steer = aimToTarget - vdata.vel
	--print(steer)
	
	 --local dirDiff = -math.asin(vdata.dirVec:cross(vdata.dirVecUp):dot(desired))
	--targetPos = aiPos + (aiPos - player.pos) * 100
	return dirDiff, dirTarget
end
local function predict()
	-- local vel
	--if Arena == 5 then
		--vel  = vec3(-1,0,0)
		--local speed = vdata.vel:length()
		--if speed < 5 then 
		--speed = 8
		--end
		--vel = vel * speed
	--else
		local vel  = vdata.vel:normalized()
		local speed =  vdata.vel:length()
		if speed < 5 then
		speed = 20 
		end
		vel = vel * speed
	--end
	local lookahead = vdata.pos + vdata.vel
	return lookahead
end 
local function getNormalPoint(p, a, b)
	local ap = p - a
	local ab = (b - a):normalized()

	ab = ab * (ap:dot(ab))
	local normalPoint = a + ab
	return normalPoint
end
local function separate()
	local sum = nil
	local count = 0 
	local desiredseparation = 5 
	dump(tdata)
	for id,v in pairs(tdata) do
		local d = vdata.pos:distance(v.pos)
		if d > 0 and d < desiredseparation then
		 local diff = (vdata.pos - tdata[id].pos):normalized()
		 diff = diff / d
		 sum = sum + diff
		 count = count + 1
		end
	end
	if count > 0 then
		sum = sum / count
		sum = sum * maxspeed
		local steer = sum - vdata.vel
		return steer
	end

end
local function gasbrake(dirTarget)
	local max = 1
	local adjust = 0.01
	local lowadjust = 0.03
	local vel = vdata.vel:length()
	local steer = nil
	local vehicleClass = scenario_derby_main.vehicleClass

	if data.target ~= nil then
	if vel > 4 and dirTarget > .96  then 
		 data.throttle = data.throttle + adjust
		 data.brake = 0	
	elseif vel > 16 and dirTarget < .92 and dirTarget > .5 then
		data.throttle = data.throttle - lowadjust
		data.brake = 0
	elseif dirTarget > -0.3 then
		data.throttle = lowadjust * 10
		data.brake = 0
	elseif  dirTarget < -0.3  then
		steer = 1.55
		data.brake = data.brake + adjust
		data.throttle = 0
	end
	end
	if data.throttle >= max then
		data.throttle = max
	elseif data.throttle < adjust then
		data.throttle = 0 
	end
	if data.brake >= max then
		data.brake = max
	elseif data.brake < adjust then
		data.brake = 0
	end
	if vehicleClass == 3  then
		if data.throttle > 0.3 then
			data.throttle = data.throttle / 1.2
		end
	end
	--print(vel)
	--print(dirTarget)
	--print(data.throttle)
	return data.throttle, data.brake, steer
end
local function applyBehaviors(vName)
	local steer, dirTarget = seek()	
	--steer = separate(vdata,tdata,vName)
	local throttle, brake, steeradjust = gasbrake(dirTarget)
	if steeradjust ~= nil then
		steer = steeradjust
	end
	scenario_derby_vehicles.driveCar(vName,-steer,throttle,brake,0)--------------------------------------------------------------------------------	
end
local function debug(test)
if data.target ~= nil then
   debugDrawer:drawSphere(data.target:toPoint3F(), 2.5, ColorF(1,0,0,0.3))
  end
 if test ~= nil then
    debugDrawer:drawSphere(test:toPoint3F(), 4, ColorF(1,0,0,0.3))
end
end
local function path()
		local predictLoc = predict()	
		local normal = nil
		local largeDis = math.huge
		local a = nil
		local b = nil
		local saveA = nil
		local saveB = nil
		local saveLine = nil
		if data.targetOut == nil then
			data.targetOut = 1
		end
		 data.target = nil
		 if pathData.line == nil then
			pathData.line = math.random(1,2)
		end
		 local p = pathData.line
		-- print(p)
		 local mapData = M.mapPath[p]
		 --dump(mapData)
		for _,raceLine in ipairs(mapData.road) do
			--print(data.targetObj.node)
			 
				a = vec3(raceLine.pos)
			--print(a)	
			local link = raceLine.links
			b = vec3(mapData.road[link].pos)
			--print(b)
			local normalPoint = getNormalPoint(predictLoc,a,b)
			--print(normalPoint)
			if normalPoint.x < a.x or normalPoint.x > b.x then
				normalPoint = b
			end
		
			local distance = predictLoc:distance(normalPoint)
			
			if distance < largeDis then
				--if raceLine.node < data.targetOut + 2 then
				largeDis = distance
				--print(distance)
				--print(normalPoint)
				normal = normalPoint
				saveA = a
				saveB = b
				saveLine =  raceLine
				--if raceLine.links == 1 then 
				--	data.targetOut = 1 
				--else
				--	data.targetOut = raceLine.node
				--end
				--end
			end
			--end
		end
			
			local pathseg = (saveB - saveA):normalized()
			local radius = saveLine.radius
			radius = saveLine.radius * 4   --saveLine.radius / 2
			pathseg = pathseg * radius		
			data.target = normal + pathseg
			--print(saveLine.links)
			--print(saveLine.node)
			--data.targetObj.node = saveLine.links
			debug(predictLoc)
end
local function intial(vName)
 	--map.objects returns objId, isactive, pos, vel, dirVec, dirVecUp, damage, objectCollisions
		vdata = map.objects[map.objectNames[vName]]
		if not vdata then return end
		tdata = map.objects 
		if not tdata then return end
		data = scenario_derby_vehicles.vehicleData[vName]
		pathData = scenario_derby_vehicles.pathData[vName]
		if not M.mapPath[1] then scenario_derby_race.getRoads() return end
end
local function update(vName)	
		Arena = scenario_derby_main.Arena 
		--Update Data
		intial(vName)
		path()
		applyBehaviors(vName)
end

M.update = update

return M